//
//  ContextMenu.hpp
//  gtk_channels
//
//  Created by Arnaud Blanchard on 13/10/2019.
//

#ifndef ContextMenu_hpp
#define ContextMenu_hpp

#include <gtkmm.h>
#include <stdio.h>
#include "blc_channel.h"
#include <string>
#include <vector>

#include "Process.h"


struct ContextMenu:Gtk::Menu{
    std::string program_dir;
    std::vector<blc_channel*> selected_channels;
    Glib::RefPtr<Gtk::TreeSelection> row_selection;
    
    ContextMenu(std::string program_dir);
    void after_launch(Process *process);
    void add_item(std::string name, bool shortcut, std::function<void ()>action);
    void add_separator();
    void add_program(char const *menu_name, std::string program_name, std::initializer_list<const char*> const optional_args, std::function <void(Process*)> after_launch);
};

#endif /* ContextMenu_hpp */
