//
//  Process.hpp
//  e_bash
//
//  Created by Arnaud Blanchard on 30/08/2017.
//
//

#ifndef PROCESS_H
#define PROCESS_H

#include <vector>
#include <string>
#include <thread>
#include <gtkmm.h>
#include <vte/vte.h>

struct Process{
    pid_t pid;

    std::string name;
    std::string directory;
    std::string program_name;
    std::string command_path;
    std::vector<const char*> arg_vector;
    VteTerminal *terminal;
    Gtk::Window *terminal_window=nullptr;
    std::function<void(Process *)> after_launch;
    std::function<void(int exit_status)> on_quit_callback;

    
    Process(std::string const directory, std::string const program_name, std::shared_ptr<std::vector<const char*>> const optional_arguments={});
    ~Process();
    
    void run(std::function<void(Process*)> on_launch);
    void display_terminal();
    void on_quit(std::function<void(int exit_status)> on_quit);
    void signal(int signal) const;

};
#endif /* Process_hpp */
